'use strict';

var tslib = require('tslib');
var React = require('react');
var mergeRefs = require('react-merge-refs');
var cn = require('classnames');
var hooks = require('@alfalab/hooks');
var CheckmarkCompactMIcon = require('@alfalab/icons-glyph/CheckmarkCompactMIcon');
var styles = require('./index.module.css');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);
var mergeRefs__default = /*#__PURE__*/_interopDefaultCompat(mergeRefs);
var cn__default = /*#__PURE__*/_interopDefaultCompat(cn);
var styles__default = /*#__PURE__*/_interopDefaultCompat(styles);

var Checkbox = React.forwardRef(function (_a, ref) {
    var _b;
    var checked = _a.checked, label = _a.label, hint = _a.hint, _c = _a.size, size = _c === void 0 ? 's' : _c, boxClassName = _a.boxClassName, contentClassName = _a.contentClassName, _d = _a.align, align = _d === void 0 ? 'start' : _d, addons = _a.addons, block = _a.block, onChange = _a.onChange, className = _a.className, name = _a.name, disabled = _a.disabled, inactive = _a.inactive, dataTestId = _a.dataTestId, _e = _a.indeterminate, indeterminate = _e === void 0 ? false : _e, _f = _a.hiddenInput, hiddenInput = _f === void 0 ? false : _f, error = _a.error, restProps = tslib.__rest(_a, ["checked", "label", "hint", "size", "boxClassName", "contentClassName", "align", "addons", "block", "onChange", "className", "name", "disabled", "inactive", "dataTestId", "indeterminate", "hiddenInput", "error"]);
    var labelRef = React.useRef(null);
    var focused = hooks.useFocus(labelRef, 'keyboard')[0];
    var handleChange = function (event) {
        if (onChange) {
            onChange(event, { checked: event.target.checked, name: name });
        }
    };
    var errorMessage = typeof error === 'boolean' ? '' : error;
    return (
    // eslint-disable-next-line jsx-a11y/label-has-associated-control
    React__default.default.createElement("label", { className: cn__default.default(styles__default.default.component, styles__default.default[size], styles__default.default[align], className, (_b = {},
            _b[styles__default.default.disabled] = disabled,
            _b[styles__default.default.inactive] = inactive,
            _b[styles__default.default.checked] = checked,
            _b[styles__default.default.indeterminate] = indeterminate,
            _b[styles__default.default.focused] = focused,
            _b[styles__default.default.block] = block,
            _b)), ref: mergeRefs__default.default([labelRef, ref]) },
        !hiddenInput && (React__default.default.createElement("input", tslib.__assign({ type: 'checkbox', onChange: handleChange, disabled: disabled || inactive, checked: checked, "data-test-id": dataTestId }, restProps))),
        React__default.default.createElement("span", { className: cn__default.default(styles__default.default.box, boxClassName) },
            checked && React__default.default.createElement(CheckmarkCompactMIcon.CheckmarkCompactMIcon, { className: styles__default.default.checkedIcon }),
            indeterminate && !checked && React__default.default.createElement("span", { className: styles__default.default.indeterminateLine })),
        (label || hint || errorMessage) && (React__default.default.createElement("span", { className: cn__default.default(styles__default.default.content, contentClassName) },
            label && React__default.default.createElement("span", { className: styles__default.default.label }, label),
            hint && !errorMessage && React__default.default.createElement("span", { className: styles__default.default.hint }, hint),
            errorMessage && (React__default.default.createElement("span", { className: styles__default.default.errorMessage, role: 'alert' }, errorMessage)))),
        addons && React__default.default.createElement("span", { className: styles__default.default.addons }, addons)));
});
/**
 * Для отображения в сторибуке
 */
Checkbox.defaultProps = {
    indeterminate: false,
};

exports.Checkbox = Checkbox;
